/*
 DSPRobotics
 PIC Clicker LED Dispaly - HID  V1.00    (PIC Clicker)
 Language: Mikro C Pro
 Chip: P18F47J53
 CLK: 48Mhz
 
 Aplication: Ideal for using with the FlowStone Graphical Programming Language.
 www.dsprobotics.com

 */
/*---------------------------------------------------------------*/
// USB buffers
unsigned char readbuff[64] absolute 0x500;   // Buffers should be in USB RAM, please consult datasheet
unsigned char writebuff[64] absolute 0x540;
//General
char kk;
char i;
// pin definitions
//LEDs
sbit LD1 at LATA0_bit;    //LED 1
sbit LD2 at LATA1_bit;    //LED 2
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;
//Button Inputs
sbit T1 at RD3_bit;   //Button 1
sbit T2 at RD2_bit;   //Button 2
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;
//LED Disp
short int cnt = 0;
unsigned int wait_time, current_duty;
sbit HC595_cs at RB3_bit;
sbit HC595_cs_direction at TRISB3_bit;

sbit HC595_rst at RB2_bit;
sbit HC595_rst_direction at TRISB2_bit;

sbit HC595_pwm at RC6_bit;
sbit HC595_pwm_direction at TRISC6_bit;
/*---------------------------------------------------------------*/
const unsigned short CharTable[33]={
//  Sevensegment bit order
    0x7E, // '0'   (g)(f)(e)(d)(c)(a)(b)(dp)
    0x0A, // '1'    _a_
    0xB6, // '2'  f|   |b
    0x9E, // '3'   |_g_|
    0xCA, // '4'  e|   |c
    0xDC, // '5'   |_d_|.dp
    0xFC, // '6'
    0x0E, // '7'
    0xFE, // '8'
    0xDE, // '9'
    0xEE, // 'A'
    0xF8, // 'B'
    0x74, // 'C'
    0xBA, // 'D'
    0xF4, // 'E'
    0xE4, // 'F'
    0x7C, // 'G'
    0xEA, // 'H'
    0x0A, // 'I'
    0x3A, // 'J'
    0x70, // 'L'
    0x6E, // 'N'
    0x7E, // 'O'
    0xE6, // 'P'
    0xCE, // 'Q'
    0x64, // 'R'
    0xDC, // 'S'
    0xF0, // 'T'
    0x7A, // 'U'
    0xDA, // 'Y'
    0x10, // '_'
    0x80, // '-'
    0x01, // '.'
};
/*---------------------------------------------------------------*/
// Interrupt routine
void interrupt() {

 USB_Interrupt_Proc();                   // USB servicing is done inside the interrupt
}
/*---------------------------------------------------------------*/
void clear_USB_buffers()
{
   for (i=0; i<63;i++)
   {
   readbuff[i] = 0;
   writebuff[i] = 0;
   }
}
/*---------------------------------------------------------------*/
char read_button1() {
  if (Button(&PORTD, 3, 2, 0)) {               // Detect logical one
      return  1;                              // Update flag
    } else return 0;
}
/*---------------------------------------------------------------*/
char read_button2() {
  if (Button(&PORTD, 2, 2, 0)) {               // Detect logical one
      return  2;                              // Update flag
    } else return 0;
}
/*---------------------------------------------------------------*/
void hc_rst_fnc(void) {
  HC595_rst = 0;
  asm{nop};
  asm{nop};
  asm{nop};
  asm{nop};
  asm{nop};
  asm{nop};
  HC595_rst = 1;
}
/*---------------------------------------------------------------*/
void hc_cs_fnc(void) {
  HC595_cs = 0;
  asm{nop};
  asm{nop};
  asm{nop};
  asm{nop};
  asm{nop};
  asm{nop};
  HC595_cs = 1;
}
/*---------------------------------------------------------------*/
void Write7segDigits(unsigned char a, unsigned char b){
  SPI1_write(b);
  SPI1_write(a);
  hc_cs_fnc();
}
/*---------------------------------------------------------------*/
unsigned short GetChar(char Character){
  if ((Character >= 0) && (Character <= 33))
    return CharTable[Character];
  else
    return 0;
}
/*---------------------------------------------------------------*/
void main(){
  long cnt = 0;

  ANCON0 = 0xFF;               // Default all pins to digital
  ANCON1 = 0x1F;               //
  TRISD = 0;
  TRISB = 0;
  TRISA = 0;
  RCSTA1 = 1;
  //SPI
  HC595_cs_direction  = 0;
  HC595_rst_direction = 0;
  HC595_pwm_direction = 0;

  //Buttons
  T1_Direction = 1;         // Set direction for buttons
  T2_Direction = 1;
  //Leds
  LD1_Direction = 0;        // Set direction for LEDS
  LD2_Direction = 0;
  LD1 = 0;
  LD2 = 0;                 // turn off leds
  //SPI
 // SPI1_Init();            // Initialize SPI
  SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
  Delay_ms(300);
  PWM9_Init(2000);        // Initialize PWM module
  PWM9_Start();
  Delay_ms(100);
  hc_rst_fnc(); //Reset 7Seg board
 //HID
  clear_USB_buffers();
  HID_Enable(&readbuff,&writebuff);       // Enable HID communication
 /*---------------------------------------------------------------*/
 //Main Loop
  while (1){
  //USB
  kk = HID_Read();
  if (kk != 0)
  {
  //Servo PWM
   PWM9_Set_Duty(readbuff[1]);
  //7Seg
    Write7segDigits(GetChar(readbuff[2]),GetChar(readbuff[3]));  //7 segment display
   //LEDS
   if ((readbuff[0] & 0x01 )> 0) {
     LD1 = 1;
   }  else LD1 = 0;
   if ((readbuff[0] & 0x02 )> 0) {
     LD2 = 1;
   }  else LD2 = 0;
   //Buttons
   writebuff[0]=0;
   writebuff[0] = writebuff[0] | read_button1() ;
   writebuff[0] = writebuff[0] | read_button2() ;
   //HID
   HID_Write(&writebuff,64);
  }
 }
}