#line 1 "C:/Users/Carl/Documents/Pic Projects/Pic18/PIC Clicker LED Display Click/PIC Clicker LED Display Click.c"
#line 14 "C:/Users/Carl/Documents/Pic Projects/Pic18/PIC Clicker LED Display Click/PIC Clicker LED Display Click.c"
unsigned char readbuff[64] absolute 0x500;
unsigned char writebuff[64] absolute 0x540;

char kk;
char i;


sbit LD1 at LATA0_bit;
sbit LD2 at LATA1_bit;
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

sbit T1 at RD3_bit;
sbit T2 at RD2_bit;
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

short int cnt = 0;
unsigned int wait_time, current_duty;
sbit HC595_cs at RB3_bit;
sbit HC595_cs_direction at TRISB3_bit;

sbit HC595_rst at RB2_bit;
sbit HC595_rst_direction at TRISB2_bit;

sbit HC595_pwm at RC6_bit;
sbit HC595_pwm_direction at TRISC6_bit;

const unsigned short CharTable[33]={

 0x7E,
 0x0A,
 0xB6,
 0x9E,
 0xCA,
 0xDC,
 0xFC,
 0x0E,
 0xFE,
 0xDE,
 0xEE,
 0xF8,
 0x74,
 0xBA,
 0xF4,
 0xE4,
 0x7C,
 0xEA,
 0x0A,
 0x3A,
 0x70,
 0x6E,
 0x7E,
 0xE6,
 0xCE,
 0x64,
 0xDC,
 0xF0,
 0x7A,
 0xDA,
 0x10,
 0x80,
 0x01,
};


void interrupt() {

 USB_Interrupt_Proc();
}

void clear_USB_buffers()
{
 for (i=0; i<63;i++)
 {
 readbuff[i] = 0;
 writebuff[i] = 0;
 }
}

char read_button1() {
 if (Button(&PORTD, 3, 2, 0)) {
 return 1;
 } else return 0;
}

char read_button2() {
 if (Button(&PORTD, 2, 2, 0)) {
 return 2;
 } else return 0;
}

void hc_rst_fnc(void) {
 HC595_rst = 0;
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 HC595_rst = 1;
}

void hc_cs_fnc(void) {
 HC595_cs = 0;
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 HC595_cs = 1;
}

void Write7segDigits(unsigned char a, unsigned char b){
 SPI1_write(b);
 SPI1_write(a);
 hc_cs_fnc();
}

unsigned short GetChar(char Character){
 if ((Character >= 0) && (Character <= 33))
 return CharTable[Character];
 else
 return 0;
}

void main(){
 long cnt = 0;

 ANCON0 = 0xFF;
 ANCON1 = 0x1F;
 TRISD = 0;
 TRISB = 0;
 TRISA = 0;
 RCSTA1 = 1;

 HC595_cs_direction = 0;
 HC595_rst_direction = 0;
 HC595_pwm_direction = 0;


 T1_Direction = 1;
 T2_Direction = 1;

 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;


 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
 Delay_ms(300);
 PWM9_Init(2000);
 PWM9_Start();
 Delay_ms(100);
 hc_rst_fnc();

 clear_USB_buffers();
 HID_Enable(&readbuff,&writebuff);


 while (1){

 kk = HID_Read();
 if (kk != 0)
 {

 PWM9_Set_Duty(readbuff[1]);

 Write7segDigits(GetChar(readbuff[2]),GetChar(readbuff[3]));

 if ((readbuff[0] & 0x01 )> 0) {
 LD1 = 1;
 } else LD1 = 0;
 if ((readbuff[0] & 0x02 )> 0) {
 LD2 = 1;
 } else LD2 = 0;

 writebuff[0]=0;
 writebuff[0] = writebuff[0] | read_button1() ;
 writebuff[0] = writebuff[0] | read_button2() ;

 HID_Write(&writebuff,64);
 }
 }
}
